/* System dependent definitions for L4.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#ifndef __HURD_L4_TYPES_H__
#define __HURD_L4_TYPES_H__

#include <l4/types.h>
#include <errno.h>

/* General rpc stuff.  */
typedef int msg_id_t;
typedef int msg_seqno_t;

/* The task and thread interface.  */
typedef int task_t;
typedef int thread_t;

/* The memory interface.  */
typedef int memory_allocate_flags_t;
typedef unsigned memory_page_t;

/* A user_handle_id_t identifies a handle on a particular server.  */
typedef L4_Word_t user_handle_id_t;

/* Used by users to identify a resource (i.e. the server it lives on
   and the id used to address it.  */
typedef struct
{
  user_handle_id_t id;
#ifdef IDL4
  L4_Word_t server;
#else
  L4_ThreadId_t server;
#endif
} user_handle_t;

#define USER_HANDLE_NIL ((user_handle_t) { 0, L4_nilthread })

/* fsys_t.  */
typedef user_handle_id_t fsys_t;

/* We need arrays!  */
typedef int idarray_t;
typedef int retry_type;
typedef int string_t;
typedef int data_t;

#endif /* __HURD_L4_TYPES_H__ */
