#include <string.h>
#include <assert.h>
#include <pt-internal.h>

#include <l4/l4.h>

extern void *(*_pthread_init_routine)(void);
extern int main (int argc, char **argv, char **envp);
static void __start2(int argc, char **argv, char **envp);
void exit (int);

extern L4_ThreadId_t __system_pager;
extern L4_ThreadId_t __task_server;

int
_start (L4_Word_t pager_tid, L4_Word_t task_server_tid,
	int argz_size, L4_Word_t v)
{
  char *argz = (char *) &v;
  L4_Word_t *sp;
  int i;
  int argc;
  char *a, *s;

  __system_pager = * (L4_ThreadId_t *) &pager_tid;
  __task_server = * (L4_ThreadId_t *) &task_server_tid;

  sp = (L4_Word_t *) _pthread_init_routine ();

  /* Load shit into new stack.  */
  /* envp.  */
  *(-- sp) = 0;

  for (argc = 0, a = argz; a != argz + argz_size; argc ++, a += strlen (a) + 1)
    ;
  assert (*a == 0);

  sp -= argc;
  for (i = 0, a = argz; a != argz + argz_size; i ++, a += strlen (a) + 1)
    sp[i] = (L4_Word_t) a;

  a = (char *) sp;
  *(-- sp) = (L4_Word_t) a;  /* argv.  */
  *(-- sp) = argc - 1;  /* argc - 1 (count included the concluding NUL).  */
  *(-- sp) = (L4_Word_t) &exit;

  __asm__ __volatile__ ("movl %0, %%esp	\n\t"
			"jmp __start2 \n\t"
			: /* no output */
			: "g" (sp)
			);
}

L4_ThreadId_t __system_pager;
L4_ThreadId_t __task_server;

static void
__start2 (int argc, char **argv, char **envp)
{
  exit (main (argc, argv, envp));
}

void
exit (int ret)
{
  printf ("Exit was called; ret = 0x%x.\n", ret);
  for (;;)
    L4_Yield ();
}

