#ifndef __ASSERT_H__
#define __ASSERT_H__

#ifdef	NDEBUG

# define assert(expr)		(__ASSERT_VOID_CAST (0))

#else /* Not NDEBUG.  */

# define assert(expr) \
	do \
	  if (! (expr)) \
	    { \
	      printf ("*** assertion failure ***\n" \
		      __FUNCTION__ ": " __FILE__ \
		      ":%d\n", __LINE__); \
	      enter_kdebug ("ASSERT"); \
	    } \
	while (0)

#endif /* NDEBUG.  */

#define assert_perror(err) do { assert ((err) == 0); } while (0)

#endif /* __ASSERT_H__ */
