#ifndef __VMPARAM_H__
#define __VMPARAM_H__

#include <l4/l4.h>

#define PAGE_SHIFT 12
#define PAGE_SIZE (1 << PAGE_SHIFT)
#define PAGE_MASK (~(PAGE_SIZE - 1))

typedef L4_Word_t vm_size_t;
typedef L4_Word_t vm_offset_t;

#define VM_PROT_READ (0x1)
#define VM_PROT_WRITE (0x2)
#define VM_PROT_EXECUTE (0x4)
#define VM_PROT_ALL (VM_PROT_READ | VM_PROT_WRITE | VM_PROT_EXECUTE)

/* The first and last valid virtual bytes in a normal address space.  */
#define VM_MIN_ADDRESS (0)
#define VM_MAX_ADDRESS ((L4_Word_t) (1024UL * 1024 * 1024 * 3 - 1))

#endif
