/* 
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.
   
   This file is part of the GNU Hurd.
   
   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.
   
   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.  */

#ifndef __SYS_DLMALLOCGLUE_H__
#define __SYS_DLMALLOCGLUE_H__

/* The default size of an arena.  */
extern int dlmalloc_arena_size;

/* When to allocate a chunk rather than using an arena.  */
extern int dlmalloc_chunk_threshold;

/* Allocate memory--will always be a multiple of PAGE_SIZE.  */
extern void *dlmalloc_allocate (int size);

/* Deallocate memory.  */
extern void demalloc_deallocate (void *memory, int size);

/* Malloc failed.  Might want to do something, e.g. panic.  */
extern void dlmalloc_failed (void);

/* Some interesting bookkeeping kept by malloc.  */
extern int dlmalloc_extant, dlmalloc_alloc, dlmalloc_free;

#endif

