/* Iterate a function over the server_handle in a class.
   Copyright (C) 1999, 2002 Free Software Foundation, Inc.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#include "server-handles.h"
#include <pthread.h>

error_t
server_handle_class_iterate (struct server_handle_class *class,
			     error_t (*fun)(void *))
{
  pthread_mutex_lock (&_server_handle_lock);
  if (class->server_handle != 0)
    {
      struct server_handle_bucket *bucket = class->server_handle->bucket;
      pthread_mutex_unlock (&_server_handle_lock);
      return _server_handle_bucket_class_iterate (bucket, class, fun, 0);
    }
  pthread_mutex_unlock (&_server_handle_lock);
  return 0;
}
