/*
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "server-handles.h"
#include "sh-internal.h"
#include <pthread.h>

user_handle_t
server_handle_create_user_handle (void *server_handle,
				  task_t target_task)
{
  error_t err;
  struct server_handle_info *sh = server_handle;
  user_handle_t uh;

  pthread_mutex_lock (&_server_handle_lock);
  err = _user_handle_create (sh, &uh, target_task);
  pthread_mutex_unlock (&_server_handle_lock);

  return err ? USER_HANDLE_NIL : uh;
}
