/* 
   Copyright (C) 1995, 2002 Free Software Foundation, Inc.
   Written by Michael I. Bushnell.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "server-handles.h"
#include "sh-internal.h"
#include <pthread.h>
#include <hurd/ihash.h>

void *
server_handle_lookup (struct server_handle_bucket *bucket,
		      server_handle_t h,
		      struct server_handle_class *class)
{
  struct server_handle_info *sh;
  
  pthread_mutex_lock (&_server_handle_lock);

  sh = _server_handle_info_lookup (bucket, h);

  if (sh && class && sh->class != class)
    sh = 0;

  if (sh)
    sh->refcnt++;

  pthread_mutex_unlock (&_server_handle_lock);
  
  return sh;
}

  
