/* 
   Copyright (C) 1995, 2002 Free Software Foundation, Inc.
   Written by Michael I. Bushnell.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "server-handles.h"
#include <pthread.h>
#include <assert.h>

void
server_handle_resume_server_handle_rpcs (void *server_handle_struct)
{
  struct server_handle_info *pi = server_handle_struct;
  
  pthread_mutex_lock (&_server_handle_lock);
  
  assert (pi->flags & SERVER_HANDLE_INHIBITED);
  pi->flags &= ~SERVER_HANDLE_INHIBITED;
  if (pi->flags | SERVER_HANDLE_BLOCKED)
    {
      pi->flags &= ~SERVER_HANDLE_BLOCKED;
      pthread_cond_broadcast (&_server_handle_block);
    }
  pthread_mutex_unlock (&_server_handle_lock);
}


  
