#include "server-handles.h"

error_t _server_bucket_init (struct server_handle_bucket *b);

/* Allocate microkernel specific data.  Must also enter the handle
   onto the bucket's hash (i.e. sh->bucket->hentry).  */
error_t _server_handle_info_init (struct server_handle_info *sh);

/* Install the handle.  When this returns, it should be ready to
   service rpcs.  */
error_t _server_handle_info_install (struct server_handle_info *sh);

/* Deallocate microkernel specific data (does not have to remove
   itself from its bucket's hash).  */
void _server_handle_info_fini (struct server_handle_info *sh);

/* Used by server_handle_begin_rpc to confirm that an rpc is
   permitted.  */
int _server_handle_valid_rpc (struct server_handle_info *sh,
			      server_handle_t h);

/* Look up UH in bucket B and return the corresponding
   server_handle_info block.  If B is NULL, look up UH in all
   bucket.  */
struct server_handle_info *
_server_handle_info_lookup (struct server_handle_bucket *b,
			    server_handle_t sh);

/* Create a new user handle for SH in *UH for task TARGET_TASK.  */
error_t _user_handle_create (struct server_handle_info *sh,
			     user_handle_t *h,
			     task_t target_task);

/* Destroy the user handle which is associtated with SH.  */
void _user_handle_destory (struct server_handle_info *sh,
			   server_handle_t h);
