/* interrupt_operation

   Copyright (C) 1995,96, 2002 Free Software Foundation, Inc.

   Written by Miles Bader <miles@gnu.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "server-handles.h"
#include "interrupt_S.h"

/* Cause a pending request on this object to immediately return.  The
   exact semantics are dependent on the specific object.  */
error_t
S_interrupt_operation (server_handle_t sh,
		       msg_seqno_t seqno)
{
  struct server_handle_info *shi = server_handle_lookup (0, sh, 0);
  if (!shi)
    return EOPNOTSUPP;

  pthread_mutex_lock (&_server_handle_lock);
  if (shi->cancel_threshold < seqno)
    shi->cancel_threshold = seqno;
  pthread_mutex_unlock (&_server_handle_lock);

  server_handle_interrupt_rpcs (shi);
  server_handle_deref (shi);

  return 0;
}
