/* System dependent definitions for L4.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#ifndef _HURD_SERVER_HANDLES_
#warning This file should not be included directly.
#else

#include <l4/l4.h>
#include <hurd/l4/types.h>

/* Forward.  */
struct server_handle_info;

/* The demuxer function.  */
typedef int (*server_handle_demuxer_type) (L4_ThreadId_t caller,
					   L4_MsgTag_t msgtag,
					   void *msgbuf,
					   int count);

/* Each user handle maps to one of these.  */
struct user_handle_info
{
  task_t task;
  int refs;
  struct user_handle_info *next;
};

/* A user handle from the server's perspective.  */
typedef struct
{
  user_handle_id_t id;
  task_t user;
} server_handle_t;


#define SYSDEPS_SERVER_HANDLE_INFO \
  int installed; \
  /* The thread listening for requests.  */ \
  L4_ThreadId_t server; \
  /* This is not a pointer.  Most handles only have just a single
     user so we optimize for this case.  */ \
  struct user_handle_info users; \
  /* Message sequence number.  Incremented by server_handle_valid_rpc.  */ \
  msg_seqno_t seqno; \

#define SYSDEPS_SERVER_HANDLE_BUCKET

#define SYSDEPS_SERVER_HANDLE_CLASS

/* Find a user handle info block.  */
struct user_handle_info *
_user_handle_info_lookup (struct server_handle_info *shi,
			  server_handle_t sh);

#endif /* _HURD_SERVER_HANDLES_  */
