/* Initialize a handle.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#include "server-handles.h"
#include "sh-internal.h"

#include <l4/l4.h>
#include <errno.h>
#include <hurd/ihash.h>

error_t
_server_handle_info_init (struct server_handle_info *sh)
{
  error_t err;

  // #error fuck. Need to find the thread id of the server.
  /* Need to save the server thread id!  How to pass it?  Do we get it
     from the bucket?  Is that even possible?  */
  sh->server = L4_Myself ();

  sh->installed = 0;

  sh->users.task = 0;
  sh->users.refs = 0;
  sh->users.next = 0;

  err = ihash_add (sh->bucket->htable, (L4_Word_t) sh, sh, &sh->hentry);
  return err;
}
