/* Lookup a server handle given a user handle.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#include "server-handles.h"
#include "sh-internal.h"

#include <hurd/ihash.h>

struct server_handle_info *
_server_handle_info_lookup (struct server_handle_bucket *b,
			    server_handle_t sh)
{
  if (b)
    return ihash_find (b->htable, sh.id);
  else
    {
      struct server_handle_info *shi;

      for (b = _server_handle_all_buckets; b; b = b->next)
	{
	  shi = ihash_find (b->htable, sh.id);
	  if (shi)
	    return shi;
	}
    }

  return 0;
}
