/* Determine if an rpc is permitted.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#include "server-handles.h"
#include "sh-internal.h"

int
_server_handle_valid_rpc (struct server_handle_info *shi,
			  server_handle_t sh)
{
  struct user_handle_info *uhi;

  if (! shi->installed)
    return 0;

  if (shi->users.task == sh.user)
    {
      shi->seqno ++;
      return 1;
    }

  for (uhi = shi->users.next; uhi; uhi = uhi->next)
    if (uhi->task == sh.user)
      {
	shi->seqno ++;
	return 1;
      }

  return 0;
}

