#ifndef _HURD_SERVER_HANDLES_
#warning This file should not be included directly.
#else

#include <mach.h>
#include <mach/notify.h>

typedef mach_port_t server_handle_t;
typedef mach_msg_id_t msg_id_t;

#define USER_HANDLE_NIL ((user_handle_t) { 0, MACH_PORT_NULL })

/* The Mach interrupt server.  */
extern kern_return_t S_interrupt_operation (server_handle_t,
					    server_handle_seqno_t);
int server_handle_interrupt_server (msg_header_t *, msg_header_t *);

/* Type of MiG demuxer routines. */
typedef int (*server_handle_demuxer_type)(msg_header_t *inp,
					  msg_header_t *outp);

#error Put this in <hurd/mach/types.h>
typedef struct
{
  mach_port_t right;
  /* The following is a function of RIGHT.  If RIGHT is a receive
     right, then this would be MACH_MSG_TYPE_MAKE_SEND.  */
  mach_msg_type_name_t how_to_make_send_right;
} user_handle_t;

#define SYSDEPS_SERVER_HANDLE_INFO \
  mach_port_t receive_right; \
  /* MSCOUNT is used by server_handle_no_senders to check if send \
     rights were externally created.  If so, it does a delayed dealloc \
     (i.e. sets up a notification handler).  This is mach specific as \
     in L4 and unlike in Mach we cannot create additional references \
     without calling the appropriate server_handle function.  */ \
  server_handle_mscount_t mscount;

#define SYSDEPS_SERVER_HANDLE_BUCKET \
  mach_port_t portset;

#define SYSDEPS_SERVER_HANDLE_CLASS

#endif /* _HURD_SERVER_HANDLES_  */
