/* Destroy a handle.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */

#include "server-handles.h"
#include "sh-internal.h"

#include <stdlib.h>

void
_server_handle_info_fini (struct server_handle_info *sh)
{
  if (sh->hentry)
    {
      ihash_locp_remove (sh->bucket->htable, sh->hentry);
      sh->hentry = 0;
    }

  if (sh->receive_right != MACH_PORT_NULL)
    {
      err = mach_port_mod_refs (mach_task_self (), pi->port_right,
				MACH_PORT_RIGHT_RECEIVE, -1);
      assert_perror (err);

      if (sh->flags & SERVER_HANDLE_HAS_USERS)
	{
	  sh->flags &= ~SERVER_HANDLE_HAS_USERS;
	  server_handle_deref (sh);
	}
    }
}
