/* Initialize a handle.
   Copyright (C) 2002 Free Software Foundation, Inc.
   Written by Neal H. Walfield.

   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA. */


#include "server-handles.h"
#include "sh-internal.h"

#include <errno.h>
#include <mach.h>
#include <hurd/ihash.h>

error_t
_server_handle_info_init (struct server_handle_info *sh)
{
  error_t err;

  err = mach_port_allocate (mach_task_self (), MACH_PORT_RIGHT_RECEIVE,
                            &sh->receive_right);
  if (err)
    return err;

  err = ihash_add (sh->bucket->htable, sh->receive_right,
                   sh, &sh->hentry);
  if (err)
    {
      error_t err2;
      err2 = mach_mod_refs (mach_task_self (), sh->receive_right,
                           MACH_PORT_RIGHT_RECEIVE, -1);
      assert_perror (err2);
      sh->receive_right = MACH_PORT_NULL;
      return err;
    }

  sh->mscount = 0;
  return 0;
}
