#include <sys/dlmallocglue.h>
#include <machine/vmparam.h>
#include <sys/panic.h>

#include "zalloc.h"

/* The default size of an arena.  */
int dlmalloc_arena_size = 16 * PAGE_SIZE;

/* When to allocate a chunk rather than using an arena.  */
int dlmalloc_chunk_threshold = 4 * PAGE_SIZE;

/* Allocate memory--will always be a multiple of PAGE_SIZE.  */
void *
dlmalloc_allocate (int size)
{
  return zalloc (size);
}

/* Deallocate memory.  */
void
dlmalloc_deallocate (void *memory, int size)
{
  zfree (memory, size);
}

/* Malloc failed.  Might want to do something, e.g. panic.  */
void
dlmalloc_failed (void)
{
  zalloc_dump_zones (__FUNCTION__);
  printf ("extant: %d; alloced: %d; freed: %d\n",
	  dlmalloc_extant,
	  dlmalloc_alloc,
	  dlmalloc_free);
  panic ("dlmalloc_failed");
}

int
dlmalloc_lock (void)
{
  return 0;
}

int
dlmalloc_unlock (void)
{
  return 0;
}
