#ifndef __ZALLOC_H__
#define __ZALLOC_H__

#include <l4/l4.h>

/* Given a zone, return its size.  */
#define ZONE_SIZE(x) (1 << ((x) + PAGE_SHIFT))
/* Number of zones in the system.  */
#define ZONES (sizeof (L4_Word_t) * 8 - PAGE_SHIFT)

/* Add to the pool the block BLOCK of size SIZE.  Block must be page
   aligned.  */
void
zfree (void *block, L4_Word_t size);

/* Allocate a block of memory of size SIZE.  Size *must* be a multiple
   of the system page size. */
void *
zalloc (L4_Word_t size);

extern int malloc_extant;
extern int malloc_alloc;
extern int malloc_free;

/* Dump some internal data structures.  Only defined if zalloc was
   compiled with DEBUG defined.  */
void zalloc_dump_zones (char *prefix);

#endif /* __ZALLOC_H__ */
